use signalTypes;

package satcomPreprocessor is

begin logic

facet synchronizer( inSignal :: in signal;clock :: inout squareSignal;reset::in bit ) is

        initialClock::squareSignal;
	syncronize(inputSignal::signal;oldClock::squareSignal)::squareSignal;

begin state_based

        sync: if %reset
                then clock' = syncronize(inSignal,initialClock)
                else clock' = syncronize(inSignal,clock)
              endif;

end synchronizer;


facet detector(inSignal :: in signal;clock:: in squareSignal;valueBit::out bit) is

        sampleAndDetect(inputSignal::signal;clockTime::squareSignal)::bit;

begin state_based

        value: valueBit' = sampleAndDetect(inSignal,clock);

end detector;


facet uniqueWordDetector(inBit :: in bit;count:: in integer;finish::inout bit;output:: out bit) is

        uniqueWord::array(bit);
        corelationScore:: integer;
        increment(x::integer)::integer is x + 1;
        decrement(x::integer)::integer is x - 1;

begin state_based

        l1: if (count == 148)
                then (if (corelationScore < 17)
                          then output' =0
                          else output' =1
                          endif)
                         and finish' =1
                else finish' =0
                         and
                     (if (uniqueWord[count] == inBit)
                        then corelationScore' = increment(corelationScore)
                        else corelationScore' = decrement(corelationScore)
                      endif)
            endif;

end uniqueWordDetector;


facet counter(count:: inout integer;finish:: in bit) is

        increment_count(x::integer)::integer is x+1;

begin state_based

        l1:if (%finish)
		then count'=0
		else count' = increment_count(count)
	    endif;

end counter;

facet satcomPreprocessor (uniqueWordDetect,acquisitionLost,newBurst :: in
bit;inSignal :: in signal;finish,output:: out bit) is

        resetSync,reset,valueBit:: bit ;
        clockSignal::squareSignal;
        count::integer;

begin state_based

        resetsync: resetSync = %(%acquisitionLost or %newBurst);

        synchronize: synchronizer(inSignal,clockSignal,resetSync);

        detect : detector(inSignal,clockSignal,valueBit);

        uniqueWord: %uniqueWordDetect  => counter(count,finish)
and uniqueWordDetector(valueBit,count,finish,output);


end satcomPreprocessor;

end satcomPreprocessor;
