//Define a behavioural model of the satcom preprocessor


use signalTypes;

facet satcomPreprocessorBeh(uniqueWordDetect,acquisitionLost,newBurst:: in
bit;inSignal :: in signal;finish,outputUniWdDetect :: out bit) is

//local variables to store the internal clock values and the uniqueword

	uniqueWord::array(bit);
	resync,valueBit:: bit;
	clock,initialClock::squareSignal;
	count,corelationScore::integer;

//functions of the synchronizer,detector and other functions used

	decrementCount(x::integer)::integer is x - 1;
	incrementCount(x::integer)::integer is x + 1;
	detector(inSignal::signal;clockTime:: squareSignal)::bit;
	synchronize(inputSignal::signal;oldClock::squareSignal)::squareSignal;

begin state_based and continuous

//condition to find if the bit synchronizer has to be reset based on the
//input

	sync: resync = %(%acquisitionLost or %newBurst);

//the bit syncronizer that does the synchronizing of the local clock 
//with respect to the input bits received

	resyncronise: if  %resync
			then clock' = synchronize(inSignal,initialClock)
			else clock' = synchronize(inSignal,clock)
		      endif;

//The detector detects the bit  value of the received signal
	detect: valueBit' = detector(inSignal,clock);

//if the input specifies that the received bits are to be detected for the
//uniqueword then the counter increments the count and uniqueword detector 
//compares the input bit to the expected bit
 
	counter: %uniqueWordDetect and not (%finish) => count' = incrementCount(count);

	check: if count >= 148 
			then finish' = 1
			else finish' = 0
	       endif;

	uniqueDetect: %uniqueWordDetect and not(%finish) => 
					if uniqueWord[count] == valueBit
					    then corelationScore' =
incrementCount(corelationScore)
					    else corelationScore' =
decrementCount(corelationScore)
					   endif;

	output: %finish => if corelationScore =< 17 
				then outputUniWdDetect' =0
				else outputUniWdDetect' =1 
			   endif;

end satcomPreprocessorBeh;
